using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_KairosPRO._4_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._4_Vistas
{
    public partial class P_Empleados_Procesos_TraspasoBiometria : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_Empleados_Procesos_TraspasoBiometria_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public INTERNO_OpcionesDetalle_Modelo g_mdl_INTERNO_OpcionesDetalle_Modelo = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        public List<long> g_lst_ids = null;
        #endregion

        #region Objetos en pantalla
        //Exferia_CheckListBox
        internal Exferia_CheckListBox Exferia_CheckListBox_Terminales { get { return ex_chklst_P_Empleados_Procesos_Terminales; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_CantidadEmpleadosSeleccionados { get { return ex_lbl_P_Empleados_Procesos_CantiadEmpleadosSeleccionados; } }

        //Label
        internal Label Label_CantidadSeleccionada { get { return lbl_P_Empleados_Procesos_CantidadSeleccionada; } }
        #endregion

        #region Constructor
        public P_Empleados_Procesos_TraspasoBiometria(string _str_Opcion,
                                                      INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                                      DateTime _dtt_FechaTrabajo,
                                                      INTERNO_OpcionesDetalle_Modelo _mdl_INTERNO_OpcionesDetalle_Modelo,
                                                      List<long> _lst_ids)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            CheckForIllegalCrossThreadCalls = false;

            //Comprobamos que el codigo del cliente exista y este bien
            if (Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO.Equals(-1))
            {
                //Avisamos y no dejamos abrir la pantalla
                Mensajes.MostrarMensaje(Mensajes.G_STR_LICENCIA_VALIDACIONES_LICENCIANOESTAACTIVA);
                Salir_P_Base();
            }

            //Empresa seleccionada y fecha de trabajo ....................................................
            P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
            P_Base_FechaTrabajo = _dtt_FechaTrabajo;

            //Listado de ids de empleados seleccionados
            g_lst_ids = _lst_ids;

            //Instanciar la controladora
            g_obj_Controladora = new P_Empleados_Procesos_TraspasoBiometria_Controladora(this);

            //Datos de Opciones detalle
            g_mdl_INTERNO_OpcionesDetalle_Modelo = _mdl_INTERNO_OpcionesDetalle_Modelo;

            g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion);

            //Mirar si hay un que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);
            }

            //Asignamos la cantidad de empleados seleccionados
            lbl_P_Empleados_Procesos_CantidadSeleccionada.Text = g_lst_ids.Count.ToString();

            //Titulo de la Pantalla ............................................................
            P_Base_TituloPantalla = _mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento;

            try
            {
                //Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                               "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Empleados_Procesos_TraspasoBiometria) + "/" + nameof(P_Empleados_Procesos_TraspasoBiometria));
                    }
                }
                //..............................................................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto............
                Enabled = false;
                //....................................................................
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                Control_Errores.Errores_Log("", ex, nameof(P_Empleados_Procesos_TraspasoBiometria) + "/" + nameof(P_Empleados_Procesos_TraspasoBiometria));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .........
                Enabled = true;
                //................................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Empleados_Procesos_TraspasoBiometria_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    g_obj_Controladora.RecargarDatos();
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Empleados_Procesos_TraspasoBiometria) + "/" + nameof(P_Empleados_Procesos_TraspasoBiometria_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        #endregion

        #region Botones AsignarEmpleados, DesasignarEmpleados, SeleccionarTodos, DesseleccionarTodos
        private void ex_btn_P_Empleado_Procesos_Asignar_Click(object sender, EventArgs e)
        {
            Grabar(true);
        }
        private void ex_btn_P_Empleado_Procesos_Desasignar_Click(object sender, EventArgs e)
        {
            Grabar(false);
        }
        private void Grabar(bool _bol_Asignacion)
        {
            if ( //Añadir
                 (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                 //Modificar
                 (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(_bol_Asignacion);
            }
        }

        private void ex_btn_P_Empleados_Procesos_SeleccionarTodo_Click(object sender, EventArgs e)
        {
            SeleccionarTodo();   
        }
        private void SeleccionarTodo()
        {
            for (int int_Contador = 0; int_Contador < ex_chklst_P_Empleados_Procesos_Terminales.Items.Count; int_Contador++)
            { ex_chklst_P_Empleados_Procesos_Terminales.SetItemChecked(int_Contador, true); }
        }

        private void ex_btn_P_Empleados_Procesos_DeseleccionarTodo_Click(object sender, EventArgs e)
        {
            DeseleccionarTodo();
        }
        private void DeseleccionarTodo()
        {
            for (int int_Contador = 0; int_Contador < ex_chklst_P_Empleados_Procesos_Terminales.Items.Count; int_Contador++)
            { ex_chklst_P_Empleados_Procesos_Terminales.SetItemChecked(int_Contador, false); }
        }
        #endregion

    }
}
